(*$B- Aufgabe 5.7 *)
PROGRAM gauss ;
CONST nn=20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;
VAR a: matrix; b, x:vektor; i, j, n:integer;
    zeile : ARRAY[1..nn] OF integer; sing : boolean;

(*$I rueckwae (Algorithmus 5.3) *)

PROCEDURE eingabe(VAR a:matrix);
VAR i,j : integer;
BEGIN
  writeln('Matrix zeilenweise eingeben');
  FOR i:=1 TO n DO
  BEGIN
    writeln('Zeile Nr.',i:3);
    FOR j:=1 TO n DO read(a[i,j])
  END;
  FOR i:= 1 TO n DO zeile[i]:=i;
END;

PROCEDURE singulaer;
BEGIN
  writeln('Matrix ist singulaer');
END;

PROCEDURE vorwaertseinsetzen;
VAR i,j : integer; s:real;
BEGIN
  FOR i:=1 TO n DO x[i]:=b[zeile[i]];
  FOR i:=1 TO n DO
  BEGIN
     s:=x[i];
     FOR j:= 1 TO i-1 DO s:=s-a[i,j]*x[j];
     x[i]:=s
  END
END;


PROCEDURE elimination;
VAR i,j,k, jmax: integer; h:vektor; faktor : real;
BEGIN
   i :=0;
   REPEAT
      i:=i+1; jmax:=i;
      FOR j:=i+1 TO n DO
      IF abs(a[j,i])>abs(a[jmax,i]) THEN jmax:=j;
      sing := a[jmax,i]=0 ;
      IF sing THEN singulaer
      ELSE
      BEGIN
         (* Gleichungen tauschen *)
         IF jmax<>i THEN
         BEGIN
            h:=a[i]; a[i]:=a[jmax]; a[jmax]:=h;
            (* merken, welche Gleichungen getauscht werden: *)
            j:=zeile[i]; zeile[i]:=zeile[jmax]; zeile[jmax]:=j
         END;

         (*Elimination*)
         FOR k := i+1 TO n DO
         BEGIN
            faktor:=a[k,i]/a[i,i];
            a[k,i]:=faktor; (*Faktoren fuer L abspeichern *)
            FOR j:=i+1 TO n DO
            a[k,j]:=a[k,j]-faktor*a[i,j]
         END
      END
    UNTIL (i=n) OR sing
END;

BEGIN
   writeln('Wieviele Unbekannte');read(n);
   eingabe(a);
   elimination;
   IF sing then write('partielle ');
   writeln('Dreieckszerlegung'); writeln('Matrix L:');
   FOR i:=1 TO n DO
   BEGIN
     FOR j:= 1 TO i-1 DO write(a[i,j]:8:4); writeln(1.0:8:4)
   END;
   writeln; writeln('Matrix R:');
   FOR i:=1 TO n DO
   BEGIN
      write(' ':8*i); FOR j:=i TO n DO write(a[i,j]:8:4); writeln;
   END;
   writeln; write('Permutationsvektor = ');
   FOR i:= 1 TO n DO write(zeile[i]:3); writeln;
   IF not sing THEN
   REPEAT
      writeln('neue rechte Seite b eingeben');
      FOR i :=1 TO n DO read(b[i]);
      vorwaertseinsetzen;
      rueckwaertseinsetzen(n,a,x,x);
      writeln('Loesung');
      FOR i:=1 TO n DO write(x[i]); writeln; writeln;
   UNTIL eof
END.
