(*$B- Algorithmus 4.7 *)
PROGRAM newton;
TYPE koeff = ARRAY[0..10] OF real;
VAR a,b: koeff;
    n,grad,i :integer;
    y,x,p,ps: real;

    PROCEDURE newtoniteration;
    BEGIN
      writeln('Startwert'); read(y);
      REPEAT
        x:=y; p:=0; ps:=0;
        FOR i:=n DOWNTO 0 DO
        BEGIN
          ps:=p+ps*x; p:=a[i]+p*x;
        END;
        writeln('X,P,PS',x,p,ps);
        y:=x-p/ps;
      UNTIL abs(y-x)<1e-3*abs(y);
    END;

    PROCEDURE deflation;
    BEGIN
      b[n-1]:=a[n];
      FOR i:=n-1 DOWNTO 1 DO
      b[i-1]:=b[i]*y+a[i];
      p:=b[0]*y+a[0];
      writeln('Nullstelle Nr.',grad-n+1,'. ',y,p);
      a:=b;
    END;

BEGIN
   writeln('grad, a[0],...,a[n] ?');
   read(grad); FOR i:=0 TO grad DO read(a[i]);

   FOR n:=grad DOWNTO 1 DO
   BEGIN
     newtoniteration;
     deflation;
   END;
END.
