(*$B- Algorithmus 5.6 *)
PROGRAM givens ;
CONST nn=20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;
VAR a: matrix; b,x:vektor; i,n:integer; sing : boolean;

(*$I rueckwae (Algorithmus 5.3) *)

PROCEDURE eingabe(VAR a:matrix; VAR b: vektor);
VAR i,j : integer;
BEGIN
  writeln('eine Gleichung nach der andern eingeben');
  FOR i:=1 TO n DO
  BEGIN
    writeln('Gleichung Nr.',i:3);
    FOR j:=1 TO n DO read(a[i,j]); readln(b[i]);
  END
END;

PROCEDURE singulaer;
BEGIN
  writeln('Matrix ist singulaer');
END;

PROCEDURE givenselimination;
VAR i,j,k: integer; cot,co,si,h: real;
BEGIN
 FOR i:=1 TO n DO
 BEGIN
  FOR k := i+1 TO n DO
   IF a[k,i]<>0 THEN
   BEGIN
     cot:=a[i,i]/a[k,i];
     si:=1/sqrt(1+cot*cot); co:=si*cot;
     a[i,i]:=a[i,i]*co+a[k,i]*si;
     FOR j:=i+1 TO n DO
     BEGIN
       h:=a[i,j]*co+a[k,j]*si;
       a[k,j]:=-a[i,j]*si+a[k,j]*co;
       a[i,j]:=h
     END;
     h:=b[i]*co+b[k]*si;
     b[k]:=-b[i]*si+b[k]*co;
     b[i]:=h
   END;
   IF a[i,i]=0 THEN singulaer
  END
END;

BEGIN
 writeln('Wieviele Unbekannte');read(n);
 eingabe(a,b);
 givenselimination;
 IF NOT sing THEN
 BEGIN
    rueckwaertseinsetzen(n,a,b,x);
    writeln('Loesung');
    FOR i:=1 TO n DO write(x[i]);
 END
END.


